; hook_lib.asm
format MS COFF
include 'C:/fasm/INCLUDE/win32ax.inc'

extrn VirtualProtect

public _HookInstall
public _HookRemoveAll

section '.data' data readable writeable

    my_struct       rb 32     ; Структура для одного перехвата
    hook_table      rd 16     ; Таблица с перехваченными функциями
    hook_table_c    dd 0      ; Счетчик перехваченных функций

section '.code' code readable executable

    _salc = 0D6h    ; sbb al,al

    macro _aam num  ; ah=al/num;al=al mod num
    {
        db 0D4h, num
    }

    macro _aad num  ; al=ah*num+al;ah=0
    {
        db 0D5h, num
    }

VirXasm32:
    pushad
    push 000001510h
    push 0100101FFh
    push 0FFFFFF55h
    push 0FFFFFFF8h
    push 0F8FF7FA0h
    push 00F0EC40Dh
    push 007551004h
    push 001D005FFh
    push 0550D5D55h
    push 0555F0F88h
    push 0F3F3FFFFh
    push 00A0C1154h
    mov edx, esi
    mov esi, esp
    push 11001b
    push 10110000101011000000101110000000b
    push 10111111101100011111001100111110b
    push 00000000000100011110101001011000b
    mov ebx, esp
    sub esp, 110
    mov edi, esp
    cld
    push 100
    pop ecx
.xa_nxtIndx:
    bt [ebx], ecx
    db _salc
    jnc .xa_is0
    lodsb
.xa_is0:
    stosb
    loop .xa_nxtIndx
    mov esi, edx
    push 2
    pop ebx
    mov edx, ebx
.xa_NxtByte:
    lodsb
    push eax
    push eax
    cmp al, 66h
    cmove ebx, ecx
    cmp al, 67h
    cmove edx, ecx
    cmp al, 0EAh
    je .xa_jmp
    cmp al, 09Ah
    jne .xa_nocall
.xa_cll:
    inc esi
.xa_jmp:
    lea esi, [esi+ebx+3]
.xa_nocall:
    cmp al, 0C8h
    je .xa_i16
    and al, 0F7h
    cmp al, 0C2h
    jne .xa_no16
.xa_i16:
    inc esi
    inc esi
.xa_no16:
    and al, 0E7h
    cmp al, 26h
    pop eax
    je .xa_PopNxt
    cmp al, 0F1h
    je .xa_F1
    and al, 0FCh
    cmp al, 0A0h
    jne .xa_noMOV
    lea esi, [esi+edx+2]
.xa_noMOV:
    cmp al, 0F0h
    je .xa_PopNxt
.xa_F1:
    cmp al, 64h
.xa_PopNxt:
    pop eax
    je .xa_NxtByte
    mov edi, esp
    push edx
    push eax
    cmp al, 0Fh
    jne .xa_Nrm
    lodsb
.xa_Nrm:
    pushfd
    _aam 10h
    xchg cl, ah
    cwde
    cdq
    xor ebp, ebp
    popfd
    jne .xa_NrmGroup
.xa_ExtGroup:
    add edi, 53
    jecxz .xa_@3
.xa_@1:
    bt [edi], ebp
    jnc .xa_@2
    inc edx
.xa_@2:
    inc ebp
    loop .xa_@1
    jc .xa_@3
    db _salc
    cdq
.xa_@3:
    shl edx, 1
    jmp .xa_ProcOpcode
.xa_NrmGroup:
    sub cl, 4
    jns .xa_@4
    mov cl, 0Ch
    and al, 7
.xa_@4:
    jecxz .xa_4x
.xa_@5:
    adc dl, 1
    inc ebp
    bt [edi], ebp
    loop .xa_@5
    jc .xa_ProcOpcode
.xa_4x:
    shr al, 1
.xa_ProcOpcode:
    xchg cl, al
    lea edx, [edx*8+ecx]
    pop ecx
    pop ebp
    bt [edi+2], edx
    jnc .xa_noModRM
.xa_ModRM:
    lodsb
    _aam 8
    shl ah, 4
    jnc .xa_isModRM
    js .xa_enModRM
.xa_isModRM:
    pushfd
    test ebp, ebp
    jnz .xa_addr32
    sub al, 6
    jnz .xa_noSIB
    mov al, 5
.xa_addr32:
    cmp al, 4
    jne .xa_noSIB
    lodsb
    and al, 7
.xa_noSIB:
    popfd
    jc .xa_iWD
    js .xa_i8
    cmp al, 5
    jne .xa_enModRM
.xa_iWD:
    add esi, ebp
    inc esi
.xa_i8:
    inc esi
.xa_enModRM:
    test ah, 60h
    jnz .xa_noModRM
    xchg eax, ecx
    cmp al, 0F6h
    je .xa_ti8
    cmp al, 0F7h
    jne .xa_noModRM
    add esi, ebx
    inc esi
.xa_ti8:
    inc esi
.xa_noModRM:
    shl edx, 1
    bt [edi+2+17], edx
    jnc .xa_Exit
    inc edx
    bt [edi+2+17], edx
    jnc .xa_im8
    adc esi, ebx
.xa_im8:
    inc esi
.xa_Exit:
    add esp, 110+64
    sub esi, [esp+4]
    mov [esp+7*4], esi
    popad
    ret


_HookInstall:
    push ebp
    mov ebp, esp
    push esi
    push edi
    push ebx

    mov ebx, [ebp + 12]  ; HookCodeLen
    mov esi, [ebp + 8]   ; Function
    test esi, esi
    jz .fail             ; Проверка на NULL указатель

    ; Проверка на корректность размера
    test ebx, ebx
    jz .fail
    cmp ebx, 1000h       ; Максимальный разумный размер (4KB)
    ja .fail

    push ebx             ; Сохраняем оригинальный размер

.loopme:
    push ebx
    call VirXasm32
    pop ebx
    test eax, eax        ; Проверка на ошибку VirXasm32
    jz .fail_pop
    add esi, eax
    sub ebx, eax
    ja .loopme

    pop ebx              ; Восстанавливаем оригинальный размер
    neg ebx
    add ebx, [ebp + 12]  ; HookCodeLen

    ; Изменение прав доступа на RWX
    push eax
    push ecx
    push edx
    
    mov eax, [ebp + 8]   ; Function address
    mov ecx, ebx         ; Size
    push 0               ; lpflOldProtect (будет заполнено VirtualProtect)
    push 40h             ; PAGE_EXECUTE_READWRITE
    push ecx
    push eax
    call VirtualProtect
    test eax, eax        ; Проверка успешности вызова
    jz .fail_protect
    
    pop edx
    pop ecx
    pop eax

    ; save to old buffer
    mov edi, [ebp + 16]  ; OldCodeBuffer
    test edi, edi
    jz .fail             ; Проверка на NULL указатель
    mov esi, [ebp + 8]   ; Function

    push ebx
    call Copy_It
    pop ebx

    mov edx, [ebp + 8]   ; Function
    sub edx, ebx
    sub edx, edi
    add edx, 1
    mov byte [edi+ebx], 0E9h
    mov [edi+ebx+1], edx

    ; write new code
    xchg esi, edi
    mov esi, [ebp + 20]  ; HookCode
    test esi, esi
    jz .fail             ; Проверка на NULL указатель

    push ebx
    call Copy_It
    pop ebx

    ; Возврат прав доступа на RX
    push eax
    push ecx
    push edx
    
    mov eax, [ebp + 8]   ; Function address
    mov ecx, ebx         ; Size
    push 0               ; lpflOldProtect (будет заполнено VirtualProtect)
    push 20h             ; PAGE_EXECUTE_READ
    push ecx
    push eax
    call VirtualProtect
    test eax, eax        ; Проверка успешности вызова
    jz .fail_protect
    
    pop edx
    pop ecx
    pop eax

    mov [ebp - 4], ebx  ; Return value
    jmp .exit

.fail_protect:
    add esp, 12          ; Очистка стека после неудачного вызова VirtualProtect
    jmp .fail

.fail_pop:
    pop ebx
.fail:
    xor ebx, ebx        ; Возвращаем 0 в случае ошибки
    mov [ebp - 4], ebx

.exit:
    pop ebx
    pop edi
    pop esi
    mov esp, ebp
    pop ebp
    ret 16


Copy_It:
    push ebp
    mov ebp, esp
    push ecx
    push esi
    push edi

    mov ecx, [ebp + 8]  ; Размер
    test ecx, ecx
    jz .exit

.cp_loop:
    mov al, [esi + ecx - 1]
    mov [edi + ecx - 1], al
    loop .cp_loop

.exit:
    pop edi
    pop esi
    pop ecx
    mov esp, ebp
    pop ebp
    ret 4

_HookRemoveAll:
    push ebp
    mov ebp, esp
    push esi
    push edi
    push ebx

    mov ecx, [hook_table_c]
.rm_loop:
    test ecx, ecx
    jle .exit
    dec ecx
    push ecx
    mov eax, [hook_table+ecx*4]
    lea esi, [eax+8]           ; old code
    mov edi, [eax+24]          ; function ptr
    mov ebx, [eax+28]          ; size
    push ebx
    call Copy_It
    pop ebx
    pop ecx
    jmp .rm_loop
.exit:
    mov [hook_table_c], 0

    pop ebx
    pop edi
    pop esi
    mov esp, ebp
    pop ebp
    ret
section '.idata' import data readable
 
 library kernel32,'KERNEL32.DLL',\
        user32,'USER32.DLL',\
        gdi32,'GDI32.DLL',\
        advapi32,'ADVAPI32.DLL',\
        comctl32,'COMCTL32.DLL',\
        comdlg32,'COMDLG32.DLL',\
        shell32,'SHELL32.DLL',\
        wsock32,'WSOCK32.DLL';,\
    include 'C:\FASM\INCLUDE\api\kernel32.inc'
    include 'C:\FASM\INCLUDE\api\user32.inc'
    include 'C:\FASM\INCLUDE\api\gdi32.inc'
    include 'C:\FASM\INCLUDE\api\advapi32.inc'
    include 'C:\FASM\INCLUDE\api\comctl32.inc'
    include 'C:\FASM\INCLUDE\api\comdlg32.inc'
    include 'C:\FASM\INCLUDE\api\shell32.inc'
    include 'C:\FASM\INCLUDE\api\wsock32.inc'
