#include <iostream>
#include <windows.h>
#include "hook_lib.h"

// Оригинальная функция
extern "C" int __stdcall OriginalFunction(int a, int b) {
    std::cout << "Original function called with " << a << " and " << b << std::endl;
    return a + b;
}

// Хук-функция
extern "C" int __stdcall HookedFunction(int a, int b) {
    std::cout << "Hooked function called with " << a << " and " << b << std::endl;
    return a * b;
}

int main() {
    // Вызов оригинальной функции
    std::cout << "Result before hook: " << OriginalFunction(5, 3) << std::endl;

    // Установка хука
    void* originalCode = HookInstall(OriginalFunction);
    if (originalCode) {
        // Вызов перехваченной функции
        std::cout << "Result after hook: " << OriginalFunction(5, 3) << std::endl;

        // Удаление всех хуков
        HookRemoveAll();

        // Вызов оригинальной функции после удаления хука
        std::cout << "Result after unhook: " << OriginalFunction(5, 3) << std::endl;
    }
    else {
        std::cout << "Failed to install hook" << std::endl;
    }

    return 0;
}